<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Services;

use DateTime;
use Exception;
use Doctrine\DBAL\Connection;
use Teknisa\FIN\Services\ContabilizacaoService;
use Teknisa\FIN\Modules\MovimentacaoBancaria\Factories\Bco01500RecontabilizacaoDeTransferenciaFactory;

class Bco01500RecontabilizacaoDeTransferenciaService { 
    
    protected $factory;
    protected $lastSelectContopectblResult;
    protected $connection;
    protected $contabilizacaoService;
    
    const LANC_INVALIDO_CODE = 1;
    const LANC_FORA_DO_PERIODO_CODE = 2;
    
    
    public function __construct(Bco01500RecontabilizacaoDeTransferenciaFactory $factory, Connection $connection, ContabilizacaoService $contabilizacaoService) {
        $this->factory = $factory;
        $this->contabilizacaoService = $contabilizacaoService;
        $this->connection = $connection;
    }
    
    public function recontabilizarTransferencias($rows, $response) {
        
        $hadError = false;
        
        foreach($rows as $row) {
            $cdempresa = $row['CDEMPRESA'];
            $nrtranbanc = $row['NRTRANBANC'];
            $dttranbanc = $row['DTTRANBANC'];
            $cdfiliproc = $row['CDFILIAL'];
            
            $this->connection->beginTransaction();
            try {
                $this->contabilizacaoService->contabilizaTransferenciaBancaria($cdempresa, $nrtranbanc, $dttranbanc, $cdfiliproc);
                $this->connection->commit();
            } catch (\Exception $e) {
                $this->connection->rollback();
                $hadError = true;
            }
        }
        
        if ($hadError) {
            $this->contabilizacaoService->saveContabilizacaoData($response);
            throw new \Exception("");
        }
        
    }
    
}